/*******************************************************************************
 * Copyright (c) 2005 Intel Corporation, IBM.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Vishnu K Naikawadi, Intel - Initial API and Implementation (Based on the Java
 *                                API implementation by IBM)
 *
 * $Id: IConsole.h,v 1.2 2005/07/29 22:22:31 vnaikawadi Exp $
 *
 *******************************************************************************/



#ifndef  IConsole_H
#define  IConsole_H

#include "tptp/TPTPExport.h"
#include "tptp/client/IDataProcessor.h"


namespace TPTP
{
	namespace Client
	{

		class TPTP_CLASS_EXPORT IConsole
		{
			public:

				/**
				 * Insert the method's description here.
				 * Creation date: (2/19/01 2:56:30 PM)
				 * @param processor org.eclipse.hyades.internal.execution.local.common.DataProcessor
				 */
				virtual void setDataProcessor(IDataProcessor* processor)=0;


				virtual IDataProcessor* getDataProcessor()=0;

				/**
				 * Insert the method's description here.
				 * Creation date: (5/28/01 8:01:54 PM)
				 * @param data java.lang.String
				 */
				virtual void write(char* data) =0;


				/* Closes this console */
				virtual void close() =0;
		};

	}

}
#endif

