/**********************************************************************
 * Copyright (c) 2005, 2007 Scapa Technologies Limited and others
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DataTransferInterface.h,v 1.2 2007/04/06 01:12:28 jkubasta Exp $
 * 
 * Contributors: 
 * Scapa Technologies Limited - Initial API and implementation
 **********************************************************************/

#ifndef __DATATRANSFER_H__
#define __DATATRANSFER_H__

#include "system.h"
#include "hashtable.h"

static char* DC_KEY_MONITORING = "DC_MONITORING";
//Bug 99153
static char* DC_AGENT_CONTROLLER_STOPPED = "DC_AGENT_CONTROLLER_STOPPED";
//End
static char* DC_KEY_FINISHED = "DC_FINISHED";
static char* DC_KEY_TREE_REQUESTED = "DC_TREE_REQUESTED";
static XINT64 DC_VAL_TRUE = TRUE;
static XINT64 DC_VAL_FALSE = FALSE;

#ifdef __cplusplus
extern "C" {
#endif

#if defined(LINUX) || defined(SOLARIS) 
int DC_TransferStartup(HashTable* variables, HashTable* filters, HashTable* tree);
int DC_TransferShutdown();
int DC_SendMessage(char* msg, int off, int len);
int DC_TransferSetAgentName(char* name);
#else
int __declspec(dllexport) DC_TransferSetAgentName(char* name);
int __declspec(dllexport) DC_TransferStartup(HashTable* variables, HashTable* filters, HashTable* tree);
int __declspec(dllexport) DC_TransferShutdown();
int __declspec(dllexport) DC_SendMessage(char* msg, int off, int len);
#endif

#ifdef __cplusplus
}
#endif

#endif

