/*******************************************************************************
 * Copyright (c) 2005, 2008 Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Hoang M Nguyen, Intel - Initial API and Implementation
 * $Id: TPTPOSCalls.h,v 1.4 2008/11/25 20:51:52 jkubasta Exp $
 *******************************************************************************/ 


/**
 *********************************************************
 *
 * @file      tptpOSCalls
 *
 * @brief
 *    This provides a generic interface to OS-specific system calls
 *
 *
 *********************************************************/

#ifndef __TPTPOSCALLS_H
#define __TPTPOSCALLS_H


#include "tptp/TPTPSupportTypes.h"


extern const char OS_SPECIFIC_NAME_SEPARATOR ;


#ifdef __cplusplus
extern "C" {
#endif


TPTP_FUNC_EXPORT  char * getGlobalUniqueId() ;


TPTP_FUNC_EXPORT  int compareIgnoreCase(const char *pStr1, const char *pStr2) ;


TPTP_FUNC_EXPORT  void * loadTheModule(const char *pLibName) ;

#define UNKNOWN_EXE "unknown"

#ifdef __cplusplus
}
#endif


#endif /* __TPTPOSCALLS_H*/


