/**********************************************************************
 * Copyright (c) 2005, 2006 Scapa Technologies Limited and others
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DataCollectionInterface.h,v 1.2 2006/10/26 22:40:21 kcallaghan Exp $
 * 
 * Contributors: 
 * Scapa Technologies Limited - Initial API and implementation
 **********************************************************************/


#ifndef __DATACOLLECTION_H__
#define __DATACOLLECTION_H__

#include "system.h"
#include "hashtable.h"

static char* DC_KEY_WAITTIME = "DC_WAITTIME";
static char* REGET_CHILDREN = "REGET_CHILDREN";

#ifdef __cplusplus
extern "C" {
#endif

#if defined(LINUX) || defined(SOLARIS)
char* DC_CollectionGetAgentName();
char** DC_CollectionGetTree	(int* numresults);
char** DC_CollectionGetResults (int* numresults);
int DC_CollectionStartup(HashTable* hasht_variables, HashTable* hasht_filters, HashTable* hasht_tree);
int DC_CollectionShutdown();
#else
__declspec(dllexport) char* DC_CollectionGetAgentName();
__declspec(dllexport) char** DC_CollectionGetTree	(int* numresults);
__declspec(dllexport) char** DC_CollectionGetResults (int* numresults);
__declspec(dllexport) int DC_CollectionStartup(HashTable* hasht_variables, HashTable* hasht_filters, HashTable* hasht_tree);
__declspec(dllexport) int DC_CollectionShutdown();
#endif

#ifdef __cplusplus
}
#endif

#endif
